//
//#############################################################################################################
//
//		WebGall_EXIF 
//		Version 0.10 Beta
//
//		- Javascript fr FixFoto zur Erstellung einer Webgalerie mit Exif-Daten -
//
//		im Oktober 2003
//
//		Autoren:	Poeth   -  Thomas Poehler  -  poehler@web.de
//					Hippo6  -  Eike Biel  (EB) -  eike@hippopark.de
//
//		Das Urscript 'WebGall' von Poehler hat die Grundlage gelegt fr diese Variante, in der 
//		vorhandene Exif-Daten eines Fotos ausgewertet und zur bernahme in den HTML-Code
//		der Galerie verfgt werden.
//		Hieraus ergibt sich die wunderbare Mglichkeit, den Bildern einer Galerie  
//		Bildunterschriften hinzuzufgen. Diese knnen zuvor z. B. mit dem Script 'EditComment' von 
//		Jaques Nietsch in den Exif-Tag eingefgt werden.
//		Dem Konzept der Anpassung liegt zugrunde, dass die Galerie im Hauptfenster des Framesets einer 
//		bestehenden Webseite ausgegeben werden soll. Es erschien fr diesen Fall z. B. wichtiger einen 
//		'Home'-Link zu setzen, da davon ausgegangen wird, dass eine Kontaktaufnahme zum Authoren mindestens
//		ber das Impressum der Hauptseite erfolgen kann.
//		Feste Werte fr Variablen sollten in das Script geschrieben werden, vielleicht auch die Farbwerte 
//		fr den Hintergrund, wenn das Farblayout immer dasselbe bleiben soll.
//
//		Neue Ideen und Wnsche sind weiter willkommen. Dann natrlich *mit* Code, wie Poeth es wnscht.
//		Es ist brigens ein tolles Gefhl keine Ahnung zu haben, sich ranzumachen und zu erleben, dass
//		doch pltzlich etwas von Wert entstanden ist. Hiermit passiert. 
//		Im Forum vorher mal abklren, ob nicht schon einer dran sitzt ;)
//
//		-Eike-
//
//#############################################################################################################
{
		// Initialisierung
		//
		// Hier folgen die Variablen, die fr jede neue Galerie angepasst werden sollten:
		var TitleString  = "Titel";
		var SubTtlString = "Untertitel";

		//
		// Hier folgen Variablen, die man einmalig selbst fr seine Galerien anpassen sollte:
		var HomeURL      = "http://www.anywhere.de";
		var ImpressumURL = "http://www.anywhere.de/impressum.htm";
		var AuthorEmail  = "author@nowhere.de";
		var AuthorName;   	// wird durch EXIF belegt
							// oder es wird hier definiert und unten deaktiviert

		//  fr einen gewnschten Banner den Doppel-Slash entfernen  
		var BannerImg   = "banner.jpg";   // Banner-Variante Standard-Pic
		//  var BannerImg   = "banner_foto2100.jpg";   // Banner-Variante Fotoseite mit Camedia 2100 UZ
		//  var BannerImg   = "banner_foto1400.jpg";   // Banner-Variante Fotoseite mit Camedia 1400 XL

		var thumbwidth=10000, thumbheight=60;    // die Gre fr die Thumbnails
		var imgwidth=600, imgheight=400;         // die Gre fr die in die Seite eingebetteten Bilder
		var maxwidth=900, maxheight=600;         // die Gre fr die Popup-Bilder

		var HeaderBgCol = "0 128 128";           // Hintergrundfarbe des PageHeaders
		var FooterBgCol = "0 128 128";           // Hintergrundfarbe des PageFooters (Thumbnailbereich)
		var ImgBgCol    = "0 192 192";           // Hintergrundfarbe der eingebetteten Bilder
		var PopBgCol    = "0 192 192";           // Hintergrundfarbe der PopUp-Bilder

		//
		// Hier folgen die internen Variablen:
		var fso, f1, f2, r, icount;
		var ForReading = 1, ForWriting = 2;
		var currPic, idxPic;
		var Sh = new ActiveXObject("WScript.Shell");  // nur eine Hilfsvariable
		
		var WebBase = Sh.RegRead("HKEY_CURRENT_USER\\Software\\FixFoto\\InstPath") + "\\scripts\\webgall_exif\\newgallery\\";
		var TplBase = Sh.RegRead("HKEY_CURRENT_USER\\Software\\FixFoto\\InstPath") + "\\scripts\\webgall_exif\\tpl\\";
		var ThmbBase = WebBase + "thumbs\\";
		var PageBase = WebBase + "pages\\";
		var ImgBase  = WebBase + "images\\";
		var PicName;
           
		// EB: EXIF-Variablen
		var Make, Model;        // Kamera-Hersteller, -Modell 
		var ImageDescription;   // Bildbeschreibung, wird genutzt als Bildunterschrift 
		var FocalLength;		// Brennweite
		var ISOSpeedRatings		// ISO-Wert
		var FNumber;			// Blendenwert
		var ExposureTime;		// Belichtungszeit
		var Flash;				// Blitz-Wert, wird unten on case mit Text getauscht
		var UserComment;        // Benutzer-Kommentar, wird genutzt fr Angaben zur Nachbearbeitung
		var FlWert = "";   		// Variable fr Flash-Wert-Tausch auf Blitzangaben
		var FFwork;				// Angaben zur FixFoto-Nachbearbeitung
        //
        
		var DlgName, DlgWdth, DlgHght;
		var CtrlTop, LabelOffset, LeftOffset, CtrlHght;


	StartDialog();
	//FF_ErrorBreak("Notbremse!");

        fso = new ActiveXObject("Scripting.FileSystemObject");

        //
        // create directories, resize and copy images
        icount = FF_GetImageCount;
        if (0 < icount) {
		if (!fso.FolderExists(WebBase))
			fso.CreateFolder(WebBase);
		if (!fso.FolderExists(ThmbBase))
			fso.CreateFolder(ThmbBase);
		if (!fso.FolderExists(ImgBase))
			fso.CreateFolder(ImgBase);
		if (!fso.FolderExists(PageBase))
			fso.CreateFolder(PageBase);

		fso.CopyFile(TplBase+BannerImg, WebBase);

		for(icount = 0; icount < FF_GetImageCount; icount++) {
			currPic = FF_GetImageName(icount);
			PicName = fso.GetBaseName(currPic);
			idxPic  = ImgBase + PicName + ".jpg";

			FF_LoadImage(currPic);

			//
			// EB: Hier werden die EXIF-Daten gewonnen, wenn im Foto vorhanden (!)
			testexif = FF_HasExif
				if (testexif = 1) {
					Make				= FF_GetExifTag("Make")
					Model				= FF_GetExifTag("Model")	
					ImageDescription  	= FF_GetExifTag("ImageDescription")
					ISOSpeedRatings		= FF_GetExifTag("ISOSpeedRatings")
					FNumber				= FF_GetExifTagAdvanced("FNumber")
					ExposureTime		= FF_GetExifTagAdvanced("ExposureTime")
					FocalLength			= FF_GetExifTagAdvanced("FocalLength")
					Flash				= FF_GetExifTag("Flash")
					UserComment			= FF_GetExifTag("UserComment")
                	Copyright1			= FF_GetExifTag("copyright1")		//  wird hier deaktiviert, wennn
                															//  oben fest definiert. 
                															//	Hier von Vorteil, wenn Autoren
                															//	wechseln.
                	
				//
				// EB: Hier werden die 'Flash'-Werte vertextet
				FlWert = Flash
				switch (FlWert) {
				case "0": 
					FlWert = "Blitz: nicht gefeuert"
                        		break;
				case "1":
					FlWert = "Blitz: gefeuert"
					break;
				case "5":
					FlWert = "Blitz (TTL): reflektiertes Impulslicht nicht erkannt"
					break; 
				case "7":
					FlWert = "Blitz (TTL): reflektiertes Impulslicht erkannt" 
					break;
				case "9":
					FlWert = "Blitz: gefeuert, Blitzmodus: an"
					break;
				case "13":
					FlWert = "Blitz (TTL): gefeuert, Blitzmodus: an, reflektiertes Licht nicht erkannt" 
					break; 
				case "15":
					FlWert = "Blitz (TTL): gefeuert, Blitzmodus: an, reflektiertes Licht erkannt" 
					break;
				case "16":
					FlWert = "Blitz: nicht gefeuert, Blitzmodus: an"
					break;
				case "24":
					FlWert = "Blitz: nicht gefeuert, Blitzmodus: auto" 
					break;
				case "25":
					FlWert = "Blitz: gefeuert, Blitzmodus: auto"
					break;
				case "29":       
					FlWert = "Blitz (TTL): gefeuert, Blitzmodus: auto, reflektiertes Licht nicht erkannt" 
					break;
				case "31":
					FlWert = "Blitz (TTL): gefeuert, Blitzmodus: auto, reflektiertes Licht erkannt"
					break;
				case "32":
					FlWert = "Blitz: keine Blitzfunktion"
					break;
				case "65":
					FlWert = "Blitz: gefeuert, Rote-Augen Funktion"
					break;
				case "69":
					FlWert = "Blitz (TTL): gefeuert, Rote-Augen Funktion, reflektiertes Licht nicht erkannt"
					break;
				case "71":
					FlWert = "Blitz (TTL): gefeuert, Rote-Augen Funktion, reflektiertes Licht erkannt"
					break;
				case "73":
					FlWert = "Blitz: gefeuert, Blitzmodus: an, Rote-Augen Funktion"
					break;
				case "77":
					FlWert = "Blitz: gefeuert, Blitzmodus: an, Rote-Augen Funktion, reflektiertes Licht nicht erkannt"
					break;
				case "79":
					FlWert = "Blitz (TTL): gefeuert, Blitzmodus: an, Rote-Augen Funktion, reflektiertes Licht erkannt" 
					break;
				case "89":
					FlWert = "Blitz: gefeuert, Blitzmodus: auto, Rote-Augen Funktion"
					break;
				case "93":
					FlWert = "Blitz (TTL): gefeuert, Blitzmodus: auto, reflektiertes Licht nicht erkannt, Rote-Augen Funktion" 
					break;
				case "95":
					FlWert = "Blitz (TTL): gefeuert, Blitzmodus: auto, reflektiertes Licht erkannt, Rote-Augen Funktion"
					break;
				default: 
					FlWert = "Blitz: andere (Wert unbekannt)"
					break;
					} //switsch
				
				Flash = FlWert
                                 

				//
				// EB: Hier werden die Zusatzinformationen gebildet, wenn Exif-Tag vorhanden
				Kamera 			= Make + ",  Modell " + Model;
				Aufnahme 		= "Brennweite: " + FocalLength + " mm, ISO-Wert " + ISOSpeedRatings + ", Blendenwert F" + FNumber + ", Belichtung " + ExposureTime + " sec, " + Flash;
				FFwork			= "Angaben zur Nachbearbeitung: " + UserComment;
					
				};  //if testexif        			
				          
                //
                // Scale + Save
                FF_HQScale(imgwidth, imgheight, true);
                FF_SaveImage(idxPic,90)

                idxPic  = ImgBase + "Max" + PicName + ".jpg";
                FF_LoadImage(currPic);
                FF_HQScale(maxwidth, maxheight, true);
                FF_SaveImage(idxPic,90)

                           ParseFile( TplBase + "PageTpl.htm", PageBase + PicName + ".htm");
                           ParseFile( TplBase + "PopTpl.htm", PageBase + "Pop" + PicName + ".htm");
				
			};  // for

                   ParseFile( TplBase + "IdxTpl.htm", WebBase + "index.htm" )
		   


        //
        // Generating the html doc for the thumbnails
        f1 = fso.OpenTextFile(TplBase + "ThmbTpl.htm", ForReading)
        f2 = fso.OpenTextFile(WebBase + "thmbfrm.htm", ForWriting, true)
        while (!f1.AtEndOfStream)
        {
		r = ParseIt(f1.ReadLine());

		if (r.indexOf("@@idx") == 0 ) {
                        // create thumbnails and index entries
                     for(icount = 0; icount < FF_GetImageCount; icount++) {
                        currPic = FF_GetImageName(icount);
                        PicName = fso.GetBaseName(currPic);
                        idxPic  = ThmbBase + PicName + ".jpg";

                        FF_LoadImage(currPic);
                        FF_HQScale(thumbwidth, thumbheight, true);
                        FF_SaveImage(idxPic,0);

                                f2.writeline("<!-- Thumbnails with hyperlinks -->");
                                f2.writeline("<td align=\"center\">");
                                f2.write("<a href=\"pages/" + PicName + ".htm\"");
                                f2.write(" target=\"Top Frame\">");
                                f2.write("<img src=\"thumbs/" + PicName + ".jpg\" border=\"0\" ");
                                f2.write( "alt=\"" + PicName + "\"></a><br><br>");
                                f2.write("<a href=\"pages/" + PicName + ".htm\" target=\"Top Frame\">");
                                f2.writeline("<FONT size=\"-2\"  face=\"Verdana\" >" + PicName + ".jpg</FONT></a>");
                                f2.writeline("</td>");
                        }//for
		} // if
		else
		f2.writeline(r);
        }; //while
        
		f2.Close();
        f1.Close();

}
}

function ParseFile( infile, outfile) {
        f1 = fso.OpenTextFile(infile, ForReading)
        f2 = fso.OpenTextFile(outfile, ForWriting, true)
        while (!f1.AtEndOfStream) {
            f2.writeline(ParseIt(f1.ReadLine()));
        }; // while
        f2.Close();
        f1.Close();
        //return(void);
}

function ParseIt(textline){
        var re;

        re = /@@PicName/g;
        textline = textline.replace(re, PicName);

        re = /@@MaxPicName/g;
        textline = textline.replace(re, "Max"+PicName);

        re = /@@ttl/g;
        textline = textline.replace(re, TitleString);

        re = /@@stl/g;
        textline = textline.replace(re, SubTtlString);

        re = /@@eml/g;
        textline = textline.replace(re, AuthorEmail);

        re = /@@nme/g;
        textline = textline.replace(re, AuthorName);

        re = /@@HeaderBgCol/g;
        textline = textline.replace(re, HeaderBgCol);

        re = /@@ImgBgCol/g;
        textline = textline.replace(re, ImgBgCol);

        re = /@@PopBgCol/g;
        textline = textline.replace(re, PopBgCol);

        re = /@@FooterBgCol/g;
        textline = textline.replace(re, FooterBgCol);

        re = /@@BannerImg/g;
        textline = textline.replace(re, BannerImg);

        //
        // EB: Eigene Variablen ins HTML
        
        re = /@@HomeURL/g;
        textline = textline.replace(re, HomeURL);

        re = /@@ImpressumURL/g;
        textline = textline.replace(re, ImpressumURL);

        re = /@@Copyright1/g;
        textline = textline.replace(re, Copyright1);
        
        re = /@@ImageDescription/g;
        textline = textline.replace(re, ImageDescription);

        re = /@@Kamera/g;
        textline = textline.replace(re, Kamera);

        re = /@@Aufnahme/g;
        textline = textline.replace(re, Aufnahme);

        re = /@@FFwork/g;
        textline = textline.replace(re, FFwork);
        //
        
        return(textline);
}

function My_AddDlg( pname, pw, ph, pleftoffset, plbloffset, pctrlhght ){
        DlgName = pname;
        DlgWdth = 0;
        DlgHght = 0;
        CtrlTop = 3;
        LeftOffset  = pleftoffset;
        LabelOffset = plbloffset;
        CtrlHght = pctrlhght;
        FF_AddDialog(pname, pw, ph);
}

function My_AddCtrl( pname, ptyp, pwidth, plabel, pvalue) {
        FF_AddControl(DlgName, plabel, "STATIC", LeftOffset, CtrlTop, LabelOffset-LeftOffset, CtrlHght)
        FF_AddControl(DlgName, pname, ptyp, LabelOffset, CtrlTop, pwidth, CtrlHght)
        FF_SetControl(DlgName, pname, pvalue);
        CtrlTop = CtrlTop + 12;
}

function StartDialog() {
    var r;

    My_AddDlg("Init", 315, 90, 5, 60, 10);
    My_AddCtrl( "Titelfld", "EDIT", 250, "Titel", TitleString);
    My_AddCtrl( "UTitelfld", "EDIT", 250, "Untertitel", SubTtlString);
    // My_AddCtrl( "JNfld", "BOOL", 100, "PopUp?", "TRUE");
    My_AddCtrl( "Bitte Hintergrundfarbe whlen:", "STATIC", 100, "", "Value");
    My_AddCtrl( "HdrBgCol", "COLOR", 100, "Titel-Bereich",            HeaderBgCol);
    My_AddCtrl( "FtrBgCol", "COLOR", 100, "Thumbnail-Bereich", FooterBgCol);
    My_AddCtrl( "ImgBgCol", "COLOR", 100, "Bild-Hintergrund",  ImgBgCol);
    My_AddCtrl( "PopBgCol", "COLOR", 100, "Popup-Hintergrund", PopBgCol);
        FF_AddControl("Init", "CANCEL", "BUTTON", 250, 75, 25, CtrlHght)
        FF_AddControl("Init", "OK",     "BUTTON", 285, 75, 25, CtrlHght)
            FF_ActivateControl( "Init", "Titelfld");

  	r = FF_ShowDialog("Init");
    if (r == "CANCEL") {
                FF_CloseDialog("Init");
            FF_ErrorBreak("Abbruch durch Benutzer.");
        }

           TitleString  = FF_GetControl("Init", "Titelfld");
           SubTtlString = FF_GetControl("Init", "UTitelfld");
    HeaderBgCol = GetHexColStr(FF_GetControl("Init", "HdrBgCol"));
    FooterBgCol = GetHexColStr(FF_GetControl("Init", "FtrBgCol"));
    ImgBgCol    = GetHexColStr(FF_GetControl("Init", "ImgBgCol"));
    PopBgCol    = GetHexColStr(FF_GetControl("Init", "PopBgCol"));

    r = FF_GetControl("Init", "HdrBgCol")+" "+
            FF_GetControl("Init", "FtrBgCol")+" "+
            FF_GetControl("Init", "ImgBgCol")+" "+
            FF_GetControl("Init", "PopBgCol");

        FF_CloseDialog("Init");
}

function Dec2HexStr(nstr) {
        var r;

    r = parseInt(nstr, 10).toString(16);
    if (r.length == 1)
      r = "0" + r;
           return r;
}

function GetHexColStr(s) {
        var r = "#";

    r = r + Dec2HexStr(s.substr(0, 3))
              + Dec2HexStr(s.substr(4, 3))
              + Dec2HexStr(s.substr(8, 3));

           return r;
}